## htrace 4.2+dfsg

=== htrace-c/src/CMakeLists.txt ===
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# Build the C client for the HTrace distributed tracing system.
#

cmake_minimum_required(VERSION 2.8 FATAL_ERROR)
set(CMAKE_BUILD_TYPE, Release)  # Default to release builds

# Define "make check" as an alias for "make test."
add_custom_target(check COMMAND ctest)
enable_testing()

if (WIN32)
    MESSAGE(FATAL_ERROR "Windows support is not yet available.")
else() # UNIX
    set(CMAKE_C_FLAGS "-g ${CMAKE_C_FLAGS} -Wall -O2 -fno-strict-aliasing")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_REENTRANT") # Enable pthreads.
    if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
        # _GNU_SOURCE is needed to see all the glibc definitions.
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_GNU_SOURCE")
        # Use the 64-bit forms of off_t, etc.
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64")
    endif()
endif()

INCLUDE(CheckCSourceCompiles)
CHECK_C_SOURCE_COMPILES("int main(void) { static __thread int i = 0; return 0; }" HAVE_IMPROVED_TLS)
CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/util/build.h.cmake ${CMAKE_BINARY_DIR}/util/build.h)

get_filename_component(HTRACED_TOOL_ABSPATH "../../htrace-htraced/go/build/htracedTool" ABSOLUTE)
get_filename_component(HTRACED_ABSPATH "../../htrace-htraced/go/build/htraced" ABSOLUTE)
CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/test/test_config.h.cmake ${CMAKE_BINARY_DIR}/test/test_config.h)

find_package(PkgConfig)
pkg_check_modules(PC_JSON-C QUIET json-c)
find_path(JSON_C_INCLUDE_DIR "json.h"
    HINTS ${JSON_C_PREFIX} ${PC_JSON-C_INCLUDEDIR} ${PC_JSON-C_INCLUDE_DIRS} PATH_SUFFIXES json-c json)
find_library(JSON_C_LIBRARY NAMES json-c json libjson
    HINTS ${JSON_C_PREFIX}${PC_JSON-C_LIBDIR} ${PC_JSON-C_LIBRARY_DIRS})
IF(JSON_C_INCLUDE_DIR AND JSON_C_LIBRARY)
ELSE(JSON_C_INCLUDE_DIR AND JSON_C_LIBRARY)
    MESSAGE(FATAL_ERROR "Failed to find libjson-c. Try installing libjson-c with apt-get or yum, or install it manually from http://oss.metaparadigm.com/json-c/")
ENDIF(JSON_C_INCLUDE_DIR AND JSON_C_LIBRARY)

include_directories(${CMAKE_BINARY_DIR}
                    ${CMAKE_SOURCE_DIR}
                    ${JSON_C_INCLUDE_DIR})

if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
    set(RAND_SRC "util/rand_linux.c")
else()
    set(RAND_SRC "util/rand_posix.c")
endif()

set(SRC_ALL
    ${RAND_SRC}
    core/conf.c
    core/htracer.c
    core/scope.c
    core/span.c
    core/span_id.c
    receiver/hrpc.c
    receiver/htraced.c
    receiver/local_file.c
    receiver/noop.c
    receiver/receiver.c
    sampler/always.c
    sampler/never.c
    sampler/prob.c
    sampler/sampler.c
    util/cmp.c
    util/cmp_util.c
    util/htable.c
    util/log.c
    util/tracer_id.c
    util/string.c
    util/terror.c
    util/time.c
)

set(DEPS_ALL pthread)
IF (CMAKE_SYSTEM_NAME MATCHES "Linux")
  set(DEPS_ALL ${DEPS_ALL} rt)
ENDIF()

# The unit test version of the library, which exposes all symbols.
add_library(htrace_test STATIC
    ${SRC_ALL}
    test/mini_htraced.c
    test/span_table.c
    test/span_util.c
    test/temp_dir.c
    test/test.c
)
target_link_libraries(htrace_test ${DEPS_ALL} ${JSON_C_LIBRARY})

# Hide all symbols by default.  Only the symbols we specifically mark as
# visible should be accessable by the library user.  This should avoid
# conflicts between our function and global variable names and those of
# the host program.
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden")

# The production version of the library, which exposes only the public API.
add_library(htrace SHARED ${SRC_ALL})
target_link_libraries(htrace ${DEPS_ALL})
# Set version 4.2.0
set(HTRACE_VERSION_MAJOR "4")
set(HTRACE_VERSION_MINOR "2")
set(HTRACE_VERSION_PATCH "0")
set(HTRACE_VERSION_STRING
    "${HTRACE_VERSION_MAJOR}.${HTRACE_VERSION_MINOR}.${HTRACE_VERSION_PATCH}")
set_target_properties(htrace PROPERTIES
    VERSION ${HTRACE_VERSION_STRING}
    SOVERSION ${HTRACE_VERSION_MAJOR})

macro(add_utest utest)
    add_executable(${utest}
        ${ARGN}
    )
    target_link_libraries(${utest} htrace_test)
    add_test(${utest} ${CMAKE_CURRENT_BINARY_DIR}/${utest} ${utest})
endmacro(add_utest)

add_utest(cmp_util-unit
    test/cmp_util-unit.c
)

add_utest(conf-unit
    test/conf-unit.c
)

add_utest(htable-unit
    test/htable-unit.c
)

add_utest(htraced_rcv-unit
    test/htraced_rcv-unit.c
    test/rtest.c
)

add_executable(linkage-unit test/linkage-unit.c)
target_link_libraries(linkage-unit htrace dl)
add_test(linkage-unit ${CMAKE_CURRENT_BINARY_DIR}/linkage-unit linkage-unit)

add_utest(local_file_rcv-unit
    test/local_file_rcv-unit.c
    test/rtest.c
)

add_utest(local_file_rcvpp-unit
    test/local_file_rcv-unit.c
    test/rtestpp.cc
)

add_utest(log-unit
    test/log-unit.c
)

add_utest(mini_htraced-unit
    test/mini_htraced-unit.c
)

add_utest(tracer_id-unit
    test/tracer_id-unit.c
)

if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
    add_utest(rand_linux-unit
        test/rand-unit.c
        util/rand_linux.c
    )
endif()
add_utest(rand_posix-unit
    test/rand-unit.c
    util/rand_posix.c
)

add_utest(sampler-unit
    test/sampler-unit.c
)

add_utest(span-unit
    test/span-unit.c
)

add_utest(span_id-unit
    test/span_id-unit.c
)

add_utest(string-unit
    test/string-unit.c
)

add_utest(temp_dir-unit
    test/temp_dir-unit.c
)

add_utest(time-unit
    test/time-unit.c
)

# Install libhtrace.so and htrace.h.
# These are the only build products that external users can consume.
install(TARGETS htrace DESTINATION lib)
install(FILES ${CMAKE_SOURCE_DIR}/core/htrace.h DESTINATION include)

## htrace 3.0.4

=== debian/changelog ===
htrace (3.0.4-1) unstable; urgency=medium

  * Initial release (Closes: #776556)

 -- Emmanuel Bourg <ebourg@apache.org>  Thu, 29 Jan 2015 08:43:23 +0100

=== debian/control ===
Source: htrace
Section: java
Priority: optional
Maintainer: Debian Java Maintainers <pkg-java-maintainers@lists.alioth.debian.org>
Uploaders: Emmanuel Bourg <ebourg@apache.org>
Build-Depends: cdbs,
               debhelper (>= 9),
               default-jdk,
               libcommons-logging-java,
               libguava-java,
               libjetty-java,
               maven-debian-helper (>= 1.5),
               thrift-compiler
Standards-Version: 3.9.6
Vcs-Git: git://anonscm.debian.org/pkg-java/htrace.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-java/htrace.git
Homepage: http://htrace.org

Package: libhtrace-core-java
Architecture: all
Depends: ${maven:Depends}, ${misc:Depends}
Suggests: ${maven:OptionalDepends}
Description: Tracing framework for distributed systems written in Java
 HTrace is a tracing framework recording spans (basic units of work, like
 a remote procedure call) and traces (set of spans forming a tree-like
 structure) to measure execution times in distributed systems.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/maven.mk

JAVA_HOME := /usr/lib/jvm/default-java

configure/libhtrace-core-java::
	# Regenerate the Java classes from the Thrift files
	bash bin/gen_thrift.sh

get-orig-source:
	uscan --download-current-version --force-download --no-symlink

=== debian/watch ===
version=3
https://github.com/cloudera/htrace/releases .*/([\d\.]+).tar.gz

## htrace 3.1.0

=== debian/changelog ===
htrace (3.1.0-3) unstable; urgency=medium

  * Team upload.
  * More informative Homepage
  * Install NOTICE.txt
  * Fix watch file
  * Add README.Debian informing users that HTrace is retired
  * Standards-Version: 4.7.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Reorder sequence of d/control fields by cme (routine-update)
  * Secure URI in copyright format (routine-update)
  * Drop useless get-orig-source target (routine-update)
  * Trim trailing whitespace.

 -- Andreas Tille <tille@debian.org>  Mon, 27 Jan 2025 20:31:40 +0100

htrace (3.1.0-2.1) unstable; urgency=medium

  * Non maintainer upload by the Reproducible Builds team.
  * No source change upload to rebuild on buildd with .buildinfo files.

 -- Holger Levsen <holger@debian.org>  Sat, 09 Jan 2021 11:42:14 +0100

htrace (3.1.0-2) unstable; urgency=medium

  * Removed the unused build dependency on libjetty-java
  * Build with the DH sequencer instead of CDBS
  * Standards-Version updated to 3.9.7 (no changes)
  * Use a secure Vcs-Git URL

 -- Emmanuel Bourg <ebourg@apache.org>  Sun, 28 Feb 2016 23:11:39 +0100

htrace (3.1.0-1) unstable; urgency=medium

  * New upstream release
    - Added a dependency on libjackson2-databind-java
    - Ignore the modules htrace-flume and htrace-hbase
    - Unshade the dependencies in htrace-core
  * Updated debian/watch to watch the new incubator repository
  * Removed the generated files from the upstream tarball
  * Added the missing build dependency on junit4

 -- Emmanuel Bourg <ebourg@apache.org>  Tue, 25 Aug 2015 16:05:48 +0200

=== debian/control ===
Source: htrace
Maintainer: Debian Java Maintainers <pkg-java-maintainers@lists.alioth.debian.org>
Uploaders: Emmanuel Bourg <ebourg@apache.org>
Section: java
Priority: optional
Build-Depends: debhelper-compat (= 13),
               default-jdk,
               junit4,
               libcommons-logging-java,
               libguava-java,
               libjackson2-databind-java,
               maven-debian-helper,
               thrift-compiler
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/java-team/htrace
Vcs-Git: https://salsa.debian.org/java-team/htrace.git
Homepage: https://incubator.apache.org/projects/htrace.html

Package: libhtrace-core-java
Architecture: all
Depends: ${maven:Depends},
         ${misc:Depends}
Suggests: ${maven:OptionalDepends}
Description: Tracing framework for distributed systems written in Java
 HTrace is a tracing framework recording spans (basic units of work, like
 a remote procedure call) and traces (set of spans forming a tree-like
 structure) to measure execution times in distributed systems.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=maven

override_dh_auto_configure:
	dh_auto_configure
	# Regenerate the Java classes from the Thrift files
	bash bin/gen_thrift.sh

override_dh_auto_clean:
	dh_auto_clean
	rm -f htrace-zipkin/src/main/java/com/twitter/zipkin/gen/*

=== debian/watch ===
version=4

https://github.com/apache/incubator-retired-htrace/tags  .*/rel/([\d\.]+).tar.gz

## htrace 4.2%2Bdfsg

=== debian/changelog ===
htrace (4.2+dfsg-1) unstable; urgency=medium

  * Team upload
  * New upstream version 4.2+dfsg (Closes: #1094407)
  * Updating d/watch and d/copyright contents to repack
  * Removing uninformative d/README.source file
  * Rewriting d/copyright
  * Updating the list of POM files in d/*.poms
  * Using javahelper to define the classpath and Dependencies
  * Build-depending on the headless JDK only

 -- Pierre Gruet <pgt@debian.org>  Sat, 01 Feb 2025 15:17:50 +0100

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #!/usr/bin/make -f
 
 %:
-	dh $@ --buildsystem=maven
+	dh $@ --buildsystem=maven --with javahelper
 
 override_dh_auto_configure:
 	dh_auto_configure

## htrace 4.2+dfsg

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,8 @@
 Section: java
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
-               default-jdk,
+               javahelper,
+               default-jdk-headless,
                junit4,
                libcommons-logging-java,
                libguava-java,
@@ -18,7 +19,7 @@
 
 Package: libhtrace-core-java
 Architecture: all
-Depends: ${maven:Depends},
+Depends: ${java:Depends},
          ${misc:Depends}
 Suggests: ${maven:OptionalDepends}
 Description: Tracing framework for distributed systems written in Java

=== debian/watch ===
version=4

opts="repack, repacksuffix=+dfsg, compression=xz, dversionmangle=auto, \
 filenamemangle=s%(?:.*?)?v?(\d[\da-z.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/apache/incubator-retired-htrace/tags  .*/rel/([\d\.]+).tar.gz
